unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    HotKey1: THotKey;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    procedure Capture();
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
  iCoolKey, //  TCoolKeys
  Menus     //  ShortCutToKey֐̂߂
  ;

var
  CoolKey: TCoolKeys = nil;

//  ---------------------------------------------------------------------------
//  }EXJ[\`揈
//  http://halbow.cool.ne.jp/Notes/N009.html
procedure DrawMouseCursor(const R: TRect; DC: HDC);
var
    CI: TCursorInfo;
    II: TIconInfo;
begin
    //  J[\1
    CI.cbSize := SizeOf(TCursorInfo);
    CI.flags := CURSOR_SHOWING;
    GetCursorInfo(CI);
    //  J[\2
    II.fIcon := false;
    GetIconInfo(CI.hCursor,II);
    DeleteObject(II.hbmColor);
    DeleteObject(II.hbmMask);
    //  zbgX|bgŒ
    CI.ptScreenPos := Point(
        CI.ptScreenPos.x - integer(II.xHotspot),
        CI.ptScreenPos.y - integer(II.yHotspot)
    );
    //  ␳
    CI.ptScreenPos := Point(CI.ptScreenPos.x - R.Left, CI.ptScreenPos.y - R.Top);
    //  `
    DrawIconEx(DC, CI.ptScreenPos.x, CI.ptScreenPos.y, CI.hCursor,
                0, 0, 0, 0, DI_DEFAULTSIZE or DI_NORMAL);
end;

//  ---------------------------------------------------------------------------
//  Lv`
procedure TForm1.Capture();
var
  WH: HWND;
  DC: HDC;
  WI: TWindowInfo;
  Rect: TRect;
  Bmp: TBitmap;
begin
  // EBhEnh
  WH := GetForegroundWindow();
  // foCXReLXg
  DC := GetWindowDC(WH);
  Bmp := TBitmap.Create;
  try
    // EBhȆ傫
    GetWindowInfo(WH, WI);
    Rect := WI.rcWindow;

    // 傫𒲐
    Bmp.Width  := Rect.Right - Rect.Left;
    Bmp.Height := Rect.Bottom - Rect.Top;

    // `
    BitBlt(Bmp.Canvas.Handle, 0, 0, Bmp.Width, Bmp.Height, DC, 0, 0, SRCCOPY);

    // }EXJ[\`
    DrawMouseCursor(Rect, Bmp.Canvas.Handle);

    //  ](ƂׂׂƏ)
    Image1.Width := Bmp.Width;
    Image1.Height := Bmp.Height;
    Image1.Picture.Bitmap.Width := Bmp.Width;
    Image1.Picture.Bitmap.Height := Bmp.Height;
    BitBlt(Image1.Picture.Bitmap.Canvas.Handle, 0, 0,
          Bmp.Width, Bmp.Height, Bmp.Canvas.Handle, 0, 0, SRCCOPY);
    //Bmp.SaveToFile(ChangeFileExt(ParamStr(0), '.bmp'));

  finally
    // DC̊J
    ReleaseDC(WH, DC);
    Bmp.Free;
  end;
end;

//  ---------------------------------------------------------------------------
//  FormCreate
procedure TForm1.FormCreate(Sender: TObject);
var
  Shift: TShiftState;
  Key: Word;
begin
  //  zbgL[𕪉
  ShortCutToKey(HotKey1.HotKey, Key, Shift);
  //  zbgL[NXɓo^(w̃L[ Capture() ֐Ăяo)
  CoolKey.Add(Capture, Shift, Key);
end;

//  ---------------------------------------------------------------------------
//  zbgL[ύX
procedure TForm1.Button1Click(Sender: TObject);
var
  Shift: TShiftState;
  Key: Word;
begin
  //  ŏ̂
  CoolKey.Delete(0);
  //  VL[zbgL[NXɓo^
  ShortCutToKey(HotKey1.HotKey, Key, Shift);
  CoolKey.Add(Capture, Shift, Key);
end;

//  ---------------------------------------------------------------------------
//  /I
initialization
  CoolKey := TCoolKeys.Create();
finalization
  CoolKey.Free;
end.
